package com.sqx.modules.order.service;

import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.service.IService;
import com.sqx.common.utils.Result;
import com.sqx.modules.order.entity.Evaluate;
import com.sqx.modules.order.entity.TbOrder;
import com.sqx.modules.utils.excel.ExcelData;
import org.springframework.transaction.annotation.Transactional;

import java.util.List;

public interface AppOrderService extends IService<TbOrder> {

    Result insertOrder(Long userId, Long shopId, Long goodsId, Integer num, Long skuId, String skuMessage, Integer orderType);

    Result print(Long orderId);

    Result updateOrder(TbOrder order);

    Result deleteOrderList(List<Integer> orderId);

    Result selectOrderList(Long userId, Long shopId, Integer status, Integer orderType, Integer page, Integer limit);

    TbOrder selectOrderByNum(String orderNum);

    Result selectAllOrder(Integer page, Integer limit, Integer status, String phone, Long shopId, String userName, String orderNumber, Integer orderType,String shopName);

    Result selectAllOrderAdmin(Integer page, Integer limit, Integer status, String phone, Long shopId, String userName,
                               String orderNumber, Integer orderType,String shopName,String riderPhone, String startTime, String endTime);

    ExcelData excelAllOrderAdmin(Integer status, String phone, Long shopId,
                                 String userName, String orderNumber, Integer orderType, String shopName,
                                 String riderPhone, String startTime, String endTime);

    Result selectOrderByUserId(Long userId, String date, String dateType);

    Result selectOrderDetails(Integer page, Integer limit, Long userId);

    Result waitTakeFood(Long userId, Integer orderType, Integer page, Integer limit, Integer status);

    List<TbOrder> selectOrderByParentId(Long parentId);

    Result selectOrderById(Long orderId);

    Result updateGoodsNum(Long orderGoodsId, Integer type, Integer num, Long shopId);

    TbOrder selectOrderByIds(Long orderId);

    Result emptyShoppingTrolley(Long userId, Long shopId);

    Result employCoupon(Long userId, Long parentId, Long couponId);

    Result deleteCouponByOrderId(Long orderId);

    Result buyGoods(Long userId, Long shopId, Long goodsId, Integer num, Long skuId, String skuMessage, Integer orderType);

    Result echoOrder(Long userId, Long shopId, Long goodsId);

    Result selectBuyGoods(Long userId, Long orderId);

    Result adminCancelOrder(Long orderId);

    Result accomplishOrder(Long orderId);


    Result accomplishOrders(Long orderId, Integer type);

    Result insertEvaluate(Evaluate evaluate);

    Result selectShoppingTrolley(Long userId);

    Result selectShoppingTrolleyByShopId(Long userId, Long shopId);

    Result userCancelOrder(Long orderId);

    Result shopReplyEvaluate(String orderNumber, String shopReplyMessage);

    Result joinOrder(Long userId, Long orderId, Long shopId, Long goodsId, Integer num, Long skuId, String skuMessage);

    Result shareTheBill(Long userId, Long shopId);

    Result selectShareTheBill(Long userId, Long orderId);

    Result deleteByGoods(Long userId, Long id);

    Result deleteShareTheBill(Long userId, Long orderId);

    Result deleteOrder(Long userId, Long orderId);

    IPage<Evaluate> getEvaluateList(Evaluate evaluate, Integer page, Integer limit);

    Result deleteEvaluateById(Long userId, Long id);
}
